/*
 * Copyright 2003-2012 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.codehaus.groovy.transform.stc;

import org.codehaus.groovy.ast.ClassNode;

/**
 * A signature codec is responsible for encoding and decoding of inferred returned types
 * as stored in bytecode. The signature must contain an appropriate version number so
 * that future versions of Groovy remain capable of decoding previous versions.
 *
 * @author Cedric Champeau
 */
public interface SignatureCodec {
    String encode(ClassNode node);

    ClassNode decode(String signature);
}
